# PatternSet

Extends \DataType

The patternset storage component. Carries all necessary data and methods for the patternset stuff.

This class handles the common description attribute and provides a default implementation for reference handling and checking for circular references that is appropriate for types that can not be nested inside elements of the same type (i.e. patternset but not path)

author | Andreas Aderhold, andi@binarycloud.com
version | $Id: b070eed1e9ac42f7ebd826ff7f3081f45e7c944d $
package | phing.types

### Methods

## add a name entry to the given list

    addPatternToList( &$list) : \PatternSetNameEntry

### Arguments

#### $list

``

### Response

`\PatternSetNameEntry`

Reference to the created PsetNameEntry instance

## Adds the patterns of the other instance to this set.

    append( $other, \Project $p)

throws |

### Arguments

#### $other

``

#### $p

`\Project`

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference() : \BuildException

inherited

### Response

`\BuildException`

## Add a name entry on the exclude list

    createExclude() : \PatternSetNameEntry

throws |

### Response

`\PatternSetNameEntry`

Reference to object

## add a name entry on the exclude files list

    createExcludesFile() : \PatternSetNameEntry

throws |

### Response

`\PatternSetNameEntry`

Reference to object

## Add a name entry on the include list

    createInclude() : \PatternSetNameEntry

throws |

### Response

`\PatternSetNameEntry`

Reference to object

## Add a name entry on the include files list

    createIncludesFile() : \PatternSetNameEntry

throws |

### Response

`\PatternSetNameEntry`

Reference to object

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference( &$stk, \Project $p) : void

inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

throws |

### Arguments

#### $stk

``

#### $p

`\Project`

## Performs the check for circular references and returns the referenced object.

    getCheckedRef( $requiredClass,  $dataTypeName) : mixed

inherited

throws |

### Arguments

#### $requiredClass

``

#### $dataTypeName

``

### Response

`mixed`

## Return the description for the current data type.

    getDescription()

inherited

retujrn | string

## Returns the filtered exclude patterns.

    getExcludePatterns(\Project $p) : array

throws |

### Arguments

#### $p

`\Project`

### Response

`array`

## Returns the filtered include patterns.

    getIncludePatterns(\Project $p) : array

throws |

### Arguments

#### $p

`\Project`

### Response

`array`

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Performs the check for circular references and returns the referenced PatternSet.

    getRef(\Project $p) : \Reference

throws |

### Arguments

#### $p

`\Project`

### Response

`\Reference`

## helper for FileSet.

    hasPatterns() : boolean

### Response

`boolean`

## Has the refid attribute of this element been set?

    isReference() : boolean

inherited

### Response

`boolean`

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Convert a array of PatternSetNameEntry elements into an array of Strings.

    makeArray(array &$list, \Project $p) : array

### Arguments

#### $list

`array`

#### $p

`\Project`

### Response

`array`

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed() : \BuildException

inherited

### Response

`\BuildException`

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

inherited

{@inheritdoc}

## Read includesfile or excludesfile if not already done so.

    readFiles(\Project $p)

throws |

### Arguments

#### $p

`\Project`

## Reads path matching patterns from a file and adds them to the includes or excludes list

    readPatterns(\PhingFile $patternfile,  &$patternlist, \Project $p)

throws |

### Arguments

#### $patternfile

`\PhingFile`

#### $patternlist

``

#### $p

`\Project`

## Sets a description of the current data type. It will be useful in commenting what we are doing.

    setDescription(string $desc) : void

inherited

### Arguments

#### $desc

`string`

## Sets the set of exclude patterns. Patterns may be separated by a comma or a space.

    setExcludes( $excludes) : void

throws |

### Arguments

#### $excludes

``

## Sets the name of the file containing the excludes patterns.

    setExcludesFile(\PhingFile $excludesFile)

throws |

### Arguments

#### $excludesFile

`\PhingFile`

file to fetch the exclude patterns from.

## Sets the set of include patterns. Patterns may be separated by a comma or a space.

    setIncludes(string $includes) : void

throws |

### Arguments

#### $includes

`string`

the string containing the include patterns

## Sets the name of the file containing the includes patterns.

    setIncludesFile(\PhingFile $includesFile)

throws |

### Arguments

#### $includesFile

`\PhingFile`

file to fetch the include patterns from.

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

### Arguments

#### $r

`\Reference`

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes() : \BuildException

inherited

### Response

`\BuildException`

## toString

    toString() : string

### Response

`string`

### Properties

## includeList

    includeList :

### Type(s)

``

## excludeList

    excludeList :

### Type(s)

``

## includesFileList

    includesFileList :

### Type(s)

``

## excludesFileList

    excludesFileList :

### Type(s)

``

## The descriptin the user has set.

    description : string

inherited

var |

### Type(s)

`string`

## Value to the refid attribute.

    ref : \Reference

inherited

var |

### Type(s)

`\Reference`

## Are we sure we don't hold circular references?

    checked : boolean

inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

var |

### Type(s)

`boolean`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`